package org.gcube.application.cms.plugins.requests;

import lombok.Data;
import org.bson.Document;
import org.gcube.application.cms.plugins.faults.InvalidPluginRequestException;
import org.gcube.application.geoportal.common.model.document.Project;
import org.gcube.application.geoportal.common.model.useCaseDescriptor.UseCaseDescriptor;

@Data
public class BaseExecutionRequest {

    UseCaseDescriptor useCaseDescriptor;
    Project document;
    Document callParameters;

    public final String getMandatory(String param) throws InvalidPluginRequestException {
        return getMandatory(param,callParameters);
    }

    public static final String getMandatory(String param,Document params) throws InvalidPluginRequestException {
        if(!params.containsKey(param)) throw new InvalidPluginRequestException("Missing mandatory parameter "+param);
        return params.getString(param);
    }

    public void validate() throws InvalidPluginRequestException {
        if(useCaseDescriptor ==null)throw new InvalidPluginRequestException("UseCaseDescriptor cannot be null ");
        if(document==null) throw new InvalidPluginRequestException("Document cannot be null");
    }
}
